From: Thomas Loimer <thomas.loimer@tuwien.ac.at>
Date: Wed Dec 11 21:36:46 2019 +0100
Bug: https://sourceforge.net/p/mcj/tickets/56/
Applied-Upstream: https://sourceforge.net/p/mcj/fig2dev/ci/c379fe50574e5b5dd6e17f15d8473c5713d1b823/
Subject: Convert polygons with too few points to polylines
    
    As a side effect, this also fixes ticket #56.

--- a/fig2dev/read.c
+++ b/fig2dev/read.c
@@ -877,8 +877,10 @@ read_ellipseobject(char *line, int line_
 /*
  * Sanitize line objects. Return 0 on success, -1 otherwise.
  * On error, call free_linestorage(l) after sanitize_lineobject().
+ *
  * polylines: remove fill, if less than 3 points
  *		remove arrows, if only one point
+ * polygons: convert to polyline if less than 3 unique points
  * rectangles, polygons: last point must coincide with first point
  * rectangle: convert to polygon, if not 5 points
  * rectangle with rounded corners: error, if not 5 points
@@ -939,6 +941,20 @@ sanitize_lineobject(
 	    q->y = l->points->y;
 	}
 
+	if (l->type == T_POLYGON) {
+		int	npts;
+
+		q = l->points;
+		for (npts = 1; q->next && npts < 4; q = q->next)
+			++npts;
+		if (npts < 4 ) {
+			put_msg("A polygon with %d points at line %d - convert to a polyline.",
+			npts, line_no);
+			l->type = T_POLYLINE;
+			return 0;
+		}
+	}
+
 	if (l->type == T_BOX || l->type == T_ARC_BOX || l->type == T_PIC_BOX) {
 	    int	npts = 1;
 	    for (q = l->points; q->next; q = q->next)
--- a/fig2dev/tests/read.at
+++ b/fig2dev/tests/read.at
@@ -135,6 +135,17 @@ A single point with a backward arrow - r
 ])
 AT_CLEANUP
 
+AT_SETUP([convert short polygon to polyline, ticket #56])
+AT_KEYWORDS(read.c polygon)
+AT_CHECK([fig2dev -L ptk <<EOF
+FIG_FILE_TOP
+2 3 0 1 -1 -1 50 -1 -1 0.0 0 0 -1 0 0 1
+	0 0
+EOF
+], 0, ignore, [A polygon with 1 points at line 11 - convert to a polyline.
+])
+AT_CLEANUP
+
 AT_SETUP([reject negative font type])
 AT_KEYWORDS(read.c font)
 AT_CHECK([fig2dev -L box <<EOF
